#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <err.h>
#include <unistd.h>
#include <util.h>

#include <sys/param.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/sockio.h>
#include <net/if.h>
#include <arpa/inet.h>

int main()
{
	int s, rc, i, count;
	struct ifconf ifc;
	char out[100];

	s = socket(AF_INET, SOCK_DGRAM, 0);
	if (s == -1)
		err(1, "socket");

	ifc.ifc_len = 0;
	ifc.ifc_req = NULL;
	rc = ioctl(s, SIOCGIFCONF, &ifc);
	if (rc == -1)
		err(1, "SIOCGIFCONF");

	ifc.ifc_buf = malloc(ifc.ifc_len);
	if (ifc.ifc_buf == NULL)
		err(1, "malloc");
	rc = ioctl(s, SIOCGIFCONF, &ifc);
	if (rc == -1)
		err(1, "SIOCGIFCONF");

	count = ifc.ifc_len / sizeof(struct ifreq);
	for (i=0; i<count; ++i) {
		sockaddr_snprintf(out, sizeof(out), "%a",
			&ifc.ifc_req[i].ifr_addr);

		printf("%d: %p %-10s %2u %s\n",
			i,
			&ifc.ifc_req[i],
			ifc.ifc_req[i].ifr_name,
			ifc.ifc_req[i].ifr_addr.sa_family,
			out
		);
	}

	free(ifc.ifc_buf);
	close(s);
}
